package com.company.euler;

import java.math.BigDecimal;
import java.util.HashSet;
import java.util.TreeSet;

/**
 * Consider all integer combinations of ab for 2 ≤ a ≤ 5 and 2 ≤ b ≤ 5:
 * <p>
 * 22=4, 23=8, 24=16, 25=32
 * 32=9, 33=27, 34=81, 35=243
 * 42=16, 43=64, 44=256, 45=1024
 * 52=25, 53=125, 54=625, 55=3125
 * If they are then placed in numerical order, with any repeats removed, we get the following sequence of 15 distinct terms:
 * <p>
 * 4, 8, 9, 16, 25, 27, 32, 64, 81, 125, 243, 256, 625, 1024, 3125
 * <p>
 * How many distinct terms are in the sequence generated by ab for 2 ≤ a ≤ 100 and 2 ≤ b ≤ 100?
 */
public class Euler29 {
    private final int MAX = 100;

    public static void main(String... args) {
        new Euler29().go();
    }

    public void go() {
        var powset = new TreeSet<BigDecimal>();

        for (int num = 2; num <= MAX; num++) {
            var base = new BigDecimal(num);
            BigDecimal powers = new BigDecimal(num);

            for (int pow = 2; pow <= MAX; pow++) {

                powers = powers.multiply(base);
                powset.add(powers);
            }
        }

        System.out.println(powset.size());
    }
}
